backend/scratch/urls.py
from django.urls import include, path
from django_utils.urls import default

urlpatterns = default.urlpatterns() + [
    path("", include("scratch_show.urls")),
]

backend/scratch_show/urls.py
from django.urls import path

from . import views

app_name = "scratch_show"

urlpatterns = [
    path("", views.IndexView.as_view(), name="index"),
    path("add", views.ScratchProjectAddView.as_view(), name="project-add"),
    path(
        "project/<int:pk>/",
        views.ScratchProjectDetailView.as_view(),
        name="project-detail",
    ),
    path(
        "event/<int:pk>/", views.EventDetailView.as_view(), name="event-detail"
    ),
]

backend/scratch_show/models.py
from datetime import date

from django.core.validators import RegexValidator
from django.db import models
from django.urls import reverse


class Event(models.Model):
    name = models.CharField("Nom de l'évènement", max_length=128)
    date = models.DateField(default=date.today)
    accept_projects = models.BooleanField(default=True)


class ScratchProject(models.Model):
    name = models.CharField("Nom du projet", max_length=128)
    author_name = models.CharField("Auteur", max_length=128)
    project_url = models.URLField(
        "Lien (url) du projet Scratch",
        validators=[
            RegexValidator(
                regex=r"https?://scratch\.mit\.edu/projects/([0-9]+)/?"
            )
        ],
    )
    event = models.ForeignKey(Event, on_delete=models.CASCADE)

    def get_absolute_url(self):
        return reverse("scratch_show:project-detail", kwargs={"pk": self.pk})

backend/scratch_show/forms.py
import re

from django import forms

from . import models

SCRATCH_ID_REGEX = re.compile(r"https://scratch\.mit\.edu/projects/([0-9]+)")


def get_scratch_id_from_url(url):
    match = SCRATCH_ID_REGEX.search(url)
    return int(match.group(1))


class ScratchURLField(forms.URLField):
    def clean(self, value):
        url = super().clean(value)
        scratch_id = get_scratch_id_from_url(url)
        return scratch_id


class ScratchProjectAddForm(forms.ModelForm):
    url = ScratchURLField(label="Lien Scratch du projet (URL)")

    class Meta:
        fields = ("name", "author_name", "url")
        model = models.ScratchProject

backend/scratch_show/views.py
from django.core.exceptions import ValidationError
from django.shortcuts import get_object_or_404
from django.utils import timezone
from django.views.generic.base import TemplateView
from django.views.generic.detail import DetailView
from django.views.generic.edit import CreateView

from . import forms, models


class IndexView(TemplateView):
    template_name = "scratch_show/index.html"

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        today = timezone.now().date()
        context["current_event"] = models.Event.objects.filter(
            date=today, accept_projects=True
        ).first()
        context["past_events"] = models.Event.objects.exclude(
            date=today, accept_projects=True
        ).order_by("-date")
        return context


class ScratchProjectAddView(CreateView):
    model = models.ScratchProject
    fields = ["name", "author_name", "project_url"]

    def dispatch(self, request, *args, **kwargs):
        self.event = get_object_or_404(
            models.Event, date=timezone.now().date(), accept_projects=True
        )
        return super().dispatch(request, *args, **kwargs)

    def form_valid(self, form):
        form.instance.event = self.event
        return super().form_valid(form)


class ScratchProjectDetailView(DetailView):
    model = models.ScratchProject


class EventDetailView(DetailView):
    model = models.Event

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        context["projects"] = models.ScratchProject.objects.filter(
            event=context["object"].pk
        )
        return context

backend/scratch_show/templates/scratch_show/base.html
{% load static %}
<html>
    <head>
        <meta charset="utf-8">
        <meta name="viewport" content="width=device-width, initial-scale=1">
        <link rel="stylesheet" href="{% static 'scratch_show/base.css' %}" />
        <link rel="icon" type="image/png" href="{% static 'scratch_show/favicon.png' %}" />
        <title>Ateliers Scratch by Prologin</title>
    </head>

    <body>

        <header class="site-header">
        <a href="/" class="header-home-link">
            <img src="https://prologin.org/static/img/logo_cube.png" alt="Prologin Cube Logo">
            <h1 class="site-title">Ateliers Scratch by Prologin</h1>
        </a>
        </header>

        <main>
            <div class="container">
                {% block content %}
                {% endblock %}
            </div>
        </main>
    </body>
</html>

backend/scratch_show/templates/scratch_show/event_detail.html
{% extends 'scratch_show/base.html' %}

{% block content %}

<h1>{{ event.name }}, le {{ event.date|date }}</h1>

<ul>
{% for project in projects %}
  <li><a href="{% url 'scratch_show:project-detail' project.pk %}">{{ project.name }}</a> par {{ project.author_name }}</li>
{% empty %}
  <li>Aucun projet pour le moment !</li>
{% endfor %}
</ul>

{% endblock %}

backend/scratch_show/templates/scratch_show/index.html
{% extends 'scratch_show/base.html' %}

{% block content %}

{% if current_event %}
<h2>Atelier en cours: <a href="{% url 'scratch_show:event-detail' current_event.pk %}">{{ current_event.name }}</a></h2>

<b><a href="{% url 'scratch_show:project-add' %}">Clique ici pour ajouter ton projet !</a></b>
{% endif %}

<h2>Ateliers passés</h2>

<ul>
{% for event in past_events %}
  <li><a href="{% url 'scratch_show:event-detail' event.pk %}">{{ event.name }}</a> le {{ event.date|date}}</li>
{% empty %}
  <li>Pas d'ancien atelier pour le moment.</li>
{% endfor %}
</ul>

{% endblock %}

backend/scratch_show/templates/scratch_show/scratchproject_detail.html
{% extends 'scratch_show/base.html' %}

{% block content %}

<h1>{{ object.name }}</h1>
<p>Créateur : {{ object.author_name }}</p>

<iframe src="{{ object.project_url }}/embed" allowtransparency="true" width="485" height="402" frameborder="0" scrolling="no" allowfullscreen></iframe>

{% endblock %}

backend/scratch_show/templates/scratch_show/scratchproject_form.html
{% extends 'scratch_show/base.html' %}

{% block content %}


<form method="post">{% csrf_token %}
    {{ form.as_p }}
    <input type="submit" value="Save">
</form>

{% endblock %}